#ifndef _FROGGER_H_
#define _FROGGER_H_

#include <D3D9.h>
#include <D3DX9.h>

#define RT_NEEDED 2


struct TVertex
{
	D3DXVECTOR3 p;
	FLOAT       tu1, tv1;
	FLOAT		tu2, tv2;
	FLOAT		tu3, tv3;

	static const DWORD FVF;

	TVertex(float inX, float inY, float inTU1, float inTV1, float inTU2, float inTV2, float inTU3, float inTV3)
		: p(inX,-inY,0), tu1(inTU1), tv1(inTV1), tu2(inTU2), tv2(inTV2), tu3(inTU3), tv3(inTV3) {}
};


class CFrogger
{
public:
	CFrogger();

	HRESULT Create(LPDIRECT3DDEVICE9 inDevice, DWORD inWidth, DWORD inHeight);
	HRESULT Destroy();
	HRESULT Invalidate();
	HRESULT Restore(DWORD width, DWORD height);

	void StartGame(DWORD inTime);
	void KeyDown(WPARAM inKey);
//	void Move(int inX, int inY); // (0,1), (0,-1), (1,0), (-1,0)
	HRESULT Render(DWORD inTime);

private:
	void SetupViewportScale();
	HRESULT RenderTechnique();
	void FillBabies();
	void SetMoveRenderTarget(int inTextureSelect);
	void SetBabiesRenderTarget(int inTextureSelect);
	void RestoreRenderTarget(); // restore rendering to back buffer

	LPDIRECT3DDEVICE9 m_Device;
    LPD3DXEFFECT      m_Effect;
	IDirect3DVertexBuffer9 * m_Quad;
	IDirect3DTexture9 * m_Background;
	IDirect3DVolumeTexture9 * m_Traffic;
	IDirect3DVolumeTexture9 * m_MiniTraffic;
	IDirect3DTexture9 * m_TrafficSpeed;
	IDirect3DTexture9 * m_Frogger;
	IDirect3DTexture9 * m_BabyFrog;
	IDirect3DTexture9 * m_GameOver;
	IDirect3DTexture9 * m_DirFromKey;
	IDirect3DTexture9 * m_SinCos;
	IDirect3DTexture9 * m_Pos[2];
	IDirect3DTexture9 * m_GameData[2];
	IDirect3DTexture9 * m_Babies[2];

	IDirect3DSurface9 * m_TargetSurface[RT_NEEDED];
	IDirect3DSurface9 * m_DefaultRenderSurface;

	// RT width and height
	DWORD m_Width;
	DWORD m_Height;

	bool m_Reset;

	bool m_NewGame;

	WPARAM m_Key;

	DWORD m_StartTime;
	DWORD m_PrevTime;
	DWORD m_ActiveSelect;
};


#endif
